/*
	$Id: DuplicateWizardException.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web;

/**
	This exception is thrown when a plug-in configuration wizard
	is open and the user tries to open a second one.

	@author Nicklas
	@version 2.0
*/
public class DuplicateWizardException
	extends RuntimeException
{

	/**
		
	*/
	private static final long serialVersionUID = 8663167575860015142L;

	/**
		Create a new exception.
	*/
	public DuplicateWizardException()
	{
		super(" Another plug-in configuration wizard is open, or it hasn't properly clean up " +
				"after itself. If you continue unsaved settings in the other wizard is lost.");
	}
	
	/**
		Create a new exception with a message.
	 	@param msg Message from the caller why the exception was thrown. 
	*/
	public DuplicateWizardException(String msg)
	{
		super(msg);
	}

	/**
		Create a new exception with a cause.
	 	@param cause The throwable object that caused the exception. 
	*/
	public DuplicateWizardException(Throwable cause)
	{
		super(cause);
	}

	/**
		Create a new exception with a cause and a message.
	 	@param msg Message from the caller about why the exception was thrown.
	 	@param cause The throwable object that caused the exception.
	*/
	public DuplicateWizardException(String msg, Throwable cause)
	{
		super(msg, cause);
	}

}

