/*
	$Id$

	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.servlet;

import java.io.BufferedReader;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.basedb.util.Values;


/**
	This is a servlet for posting reports from "Content-Security-Policy" violations.

	@see ContentSecurityPolicyFilter
	@author Nicklas
	@since 3.3
	@base.modified $Date$
*/
public final class ContentSecurityPolicyReportServlet
	extends HttpServlet
{

	private static final long serialVersionUID = -2376469451362396339L;
	
	private static final int MAX_REPORT_LENGTH = 1024;

	private static final org.slf4j.Logger log = 
		org.slf4j.LoggerFactory.getLogger(ContentSecurityPolicyReportServlet.class);
	
	@Override
	protected void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException 
	{
		int lengthRemaining = MAX_REPORT_LENGTH;
		BufferedReader reader = request.getReader();
		String line = Values.getStringOrNull(reader.readLine());
		while (line != null && lengthRemaining > 0)
		{
			lengthRemaining -= line.length();
			log.warn(line);
			line = Values.getStringOrNull(reader.readLine());
		}
	}

}
