/**
	$Id$

	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.overview.node;

import net.sf.basedb.core.Listable;
import net.sf.basedb.util.overview.Node;

/**
	Name generator used for item list members. Since we don't
	use a folder-node we must make sure that node names are unique by adding
	the id to the names.

	@author Nicklas
	@since 3.5
*/
public class ItemListMemberNameGenerator
	implements NodeNameGenerator<Listable>
{
	public ItemListMemberNameGenerator()
	{}

	/*
		From the NodeNameGenerator interface
		------------------------------------
	*/
	@Override
	public String getNodeName(Listable item, Node parentNode)
	{
		return "member." + item.getId();
	}

	@Override
	public String getNodeTitle(Listable item, Node parentNode)
	{
		return item.getName();
	}
	
	@Override
	public String getDeniedNodeName(Node parentNode)
	{
		return "member";
	}

	@Override
	public String getDeniedNodeTitle(Node parentNode)
	{
		return "Member: denied";
	}

	@Override
	public String getMissingNodeName(Node parentNode)
	{
		return "member";
	}

	@Override
	public String getMissingNodeTitle(Node parentNode)
	{
		return "Member: missing";
	}
	
	// ------------------------------------------------
	
}