/*
	$Id: TestAll.java 7837 2020-08-28 08:56:22Z nicklas $

	Copyright (C) 2005 Samuel Andersson, Johan Enell, Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
import java.util.LinkedHashMap;
import java.util.Map;

public class TestAll
{

	public static void main(String[] args)
	{
		Map<String,Boolean> results = new LinkedHashMap<String,Boolean>();
		TestUtil.checkArgs(args);
		TestUtil.begin();

		// Authorization system
		results.put("TestGroup", TestGroup.test_all());
		results.put("TestRole", TestRole.test_all());
		results.put("TestUser", TestUser.test_all());
		results.put("TestProject", TestProject.test_all());

		// Access control system
 		results.put("TestRoleKey", TestRoleKey.test_all());
 		results.put("TestProjectKey", TestProjectKey.test_all());
 		results.put("TestItemKey", TestItemKey.test_all());
 		results.put("TestPermissionTemplate", TestPermissionTemplate.test_all());

		// Settings, sessions and client
		results.put("TestClient", TestClient.test_all());
		results.put("TestHelp", TestHelp.test_all());
 		results.put("TestGlobalDefaultSetting", TestGlobalDefaultSetting.test_all());
 		results.put("TestClientDefaultSetting", TestClientDefaultSetting.test_all());
 		results.put("TestUserDefaultSetting", TestUserDefaultSetting.test_all());
 		results.put("TestUserClientSetting", TestUserClientSetting.test_all());
 		results.put("TestSession", TestSession.test_all());

		// Quota and files
 		results.put("TestQuotaType", TestQuotaType.test_all());
 		results.put("TestQuota", TestQuota.test_all());
 		results.put("TestMimeType", TestMimeType.test_all());
 		results.put("TestPath", TestPath.test_all());
 		results.put("TestDirectory", TestDirectory.test_all());
 		results.put("TestFileServer", TestFileServer.test_all());
 		results.put("TestFile", TestFile.test_all());
		results.put("TestDiskUsage", TestDiskUsage.test_all());
		results.put("TestPackedFileExporter", TestPackedFileExporter.test_all());

		// Item types, Hardware, software, protocols
		results.put("TestItemSubtype", TestItemSubtype.test_all());
 		results.put("TestHardware", TestHardware.test_all());
 		results.put("TestSoftware", TestSoftware.test_all());
 		results.put("TestProtocol", TestProtocol.test_all());
 		results.put("TestKit", TestKit.test_all());

		// File parsing
		results.put("TestFlatFileParser", TestFlatFileParser.test_all());
		results.put("TestExcelFunctions", TestExcelFunctions.test_all());
 		
		// Biomaterials
		results.put("TestBioSource", TestBioSource.test_all());
		results.put("TestSample", TestSample.test_all());
		results.put("TestExtract", TestExtract.test_all());
		results.put("TestTag", TestTag.test_all());
		results.put("TestBioPlateType", TestBioPlateType.test_all());
		results.put("TestBioPlate", TestBioPlate.test_all());
		results.put("TestBioPlateEvent", TestBioPlateEvent.test_all());

		// Annotation types and annotations
		results.put("TestQuantity", TestQuantity.test_all());
		results.put("TestUnit", TestUnit.test_all());
		results.put("TestAnnotationType", TestAnnotationType.test_all());
		results.put("TestAnnotationTypeCategory", TestAnnotationTypeCategory.test_all());
		results.put("TestAnnotation", TestAnnotation.test_all());
		results.put("TestAnnotationFlatFileImporter", TestAnnotationFlatFileImporter.test_all());
		
		// Reporters
		results.put("TestReporterType", TestReporterType.test_all());
		results.put("TestReporter", TestReporter.test_all());
		results.put("TestReporterList", TestReporterList.test_all());

		// Array LIMS -- Plates
		results.put("TestPlateGeometry", TestPlateGeometry.test_all());
		results.put("TestPlateType", TestPlateType.test_all());
		results.put("TestPlate", TestPlate.test_all());
		results.put("TestPlateMapping", TestPlateMapping.test_all());

		// Experimental platforms and data file types
		results.put("TestDataFileType", TestDataFileType.test_all());
		results.put("TestPlatform", TestPlatform.test_all());
		
		// Array LIMS -- Arrays
 		results.put("TestArrayDesign", TestArrayDesign.test_all());
 		results.put("TestArrayBatch", TestArrayBatch.test_all());
 		results.put("TestArraySlide", TestArraySlide.test_all());

		// Physical bioassays and raw data
		results.put("TestPhysicalBioAssay", TestPhysicalBioAssay.test_all());
		results.put("TestDerivedBioAssay", TestDerivedBioAssay.test_all());
 		results.put("TestRawBioAssay", TestRawBioAssay.test_all());

		// Misc
		results.put("TestSessionControl", TestSessionControl.test_all());
		results.put("TestContext", TestContext.test_all());
		results.put("TestDbControl", TestDbControl.test_all());
		results.put("TestItemList", TestItemList.test_all());
		results.put("TestNews", TestNews.test_all());
		results.put("TestMessage", TestMessage.test_all());
		results.put("TestAnyToAny", TestAnyToAny.test_all());
		results.put("TestChangeHistory", TestChangeHistory.test_all());
		results.put("TestXMLUtil", TestXMLUtil.test_all());
 		results.put("TestParameterType", TestParameterType.test_all());
		results.put("TestJarClassLoader", TestJarClassLoader.test_all());
		results.put("TestJep", TestJep.test_all());
		results.put("TestMACalculator", TestMACalculator.test_all());
		results.put("TestEncoderDecoder", TestEncoderDecoder.test_all());
		results.put("TestBfs", TestBfs.test_all());
		results.put("TestDbInfo", TestDbInfo.test_all());
		results.put("TestPresets", TestPresets.test_all());
		results.put("TestNumberFormat", TestNumberFormat.test_all());
		results.put("TestCharsetDetector", TestCharsetDetector.test_all());
		results.put("TestMetadata", TestMetadata.test_all());

		// Plugins, jobs
		results.put("TestPluginType", TestPluginType.test_all());
		results.put("TestPluginDefinition", TestPluginDefinition.test_all());
		results.put("TestPluginConfiguration", TestPluginConfiguration.test_all());
		results.put("TestJob", TestJob.test_all());
		results.put("TestJobAgent", TestJobAgent.test_all());
		results.put("TestItemImporter", TestItemImporter.test_all());
		results.put("TestReporterFlatFileImporter", TestReporterFlatFileImporter.test_all());
		results.put("TestReporterMapFlatFileImporter", TestReporterMapFlatFileImporter.test_all());
		results.put("TestPlateFlatFileImporter", TestPlateFlatFileImporter.test_all());
		results.put("TestRawDataFlatFileImporter", TestRawDataFlatFileImporter.test_all());
		results.put("TestPrintMapFlatFileImporter", TestPrintMapFlatFileImporter.test_all());
		results.put("TestGalExporter", TestGalExporter.test_all());
		results.put("TestDirty", TestDirty.test_all());
		results.put("TestIlluminaImporter", TestIlluminaImporter.test_all());
		results.put("TestGtfInputStream", TestGtfInputStream.test_all());
		results.put("TestGtfImporters", TestGtfImporters.test_all());
		
		// Experiments
		results.put("TestExtraValueType", TestExtraValueType.test_all());
		results.put("TestFormula", TestFormula.test_all());
		results.put("TestExperiment", TestExperiment.test_all());
		
		// Complex tests
		results.put("TestSourceItemTransformer", TestSourceItemTransformer.test_all());
		results.put("TestGenericOverview", TestGenericOverview.test_all());
		
		// Analysis test
		TestAnalyzeUtil.setupExperiment();
		results.put("TestBasicAnalysis", TestBasicAnalysis.test_all());
		results.put("TestReporterCloneTemplate", TestReporterCloneTemplate.test_all());
		results.put("TestIntensityCalculatorPlugin", TestIntensityCalculatorPlugin.test_all());
		results.put("TestLowessNormalization", TestLowessNormalization.test_all());
		results.put("TestMedianRatioNormalization", TestMedianRatioNormalization.test_all());
		results.put("TestBaseFileExporterImporter", TestBaseFileExporterImporter.test_all());
		results.put("TestBfsExporterImporter", TestBfsExporterImporter.test_all());
		results.put("TestBase1PluginExecuter", TestBase1PluginExecuter.test_all());
		results.put("TestExternalProgramExecutor", TestExternalProgramExecutor.test_all());
		TestAnalyzeUtil.cleanupExperiment();

		int failures = 0;
		for (Map.Entry<String,Boolean> entry : results.entrySet())
		{
			if (!entry.getValue())
			{
				System.out.println(entry.getKey() + " FAILED");
				failures++;
			}
		}
		if (failures == 0)
		{
			System.out.println("++All "+(results.size())+" tests successful!");
		}
		else
		{
			System.out.println("++"+failures + " tests failed!");
			System.out.println("++"+(results.size()-failures) + " tests succeeded!");
		}
		System.out.print("++Cleaning up. Please wait...");
		TestUtil.stop();
		System.out.println("done!");
	}

}

