<%-- $Id: submit_ownership.jsp 7703 2019-04-11 07:31:26Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Configure the order and visibility of columns in a table of items.
	This page will use the TableColumn.getTableColumns(item) to retreive the
	list of all available columns for that item type and
	getSession().getSetting(item+".columns") to retreive a comma-separated
	list of the current order of visible columns.

	@author Martin
	@version 2.9
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.util.Values"
	import="java.util.Collections"
	import="java.util.Set"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final ItemContext cc = sc.getCurrentContext(itemType, subContext);
final int maxRecent = Base.getMaxRecent(sc);

String message = null;
final DbControl dc = sc.newDbControl();
try
{
	if ("Save".equals(cmd))
	{
		Set<OwnedItem> items = cc.getObject("OwnedItems");
		User newOwner = User.getById(dc, Values.getInt(request.getParameter("owner_id")));
		cc.setRecent(Item.USER, newOwner, maxRecent);
		int numTotal = items.size();
		int numChanged =  OwnableUtil.setOwner(dc, items, newOwner);
		dc.commit();
		cc.removeObject("OwnedItems");
		if (numTotal != numChanged)
		{
			message = (numChanged == 0 ? "No" : "Only "+numChanged+" of "+numTotal) + " items got their owner changed, because you have no SET_OWNER permission";
		}
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}
if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>