<%-- $Id: merge_plates.jsp 7605 2019-02-26 10:10:15Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.CREATE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Merge plates -- step 1 of 2 -- Select mapping";
	
	// Load recently used items
	List<PlateMapping> recentPlateMappings = cc.getRecent(dc, Item.PLATEMAPPING);
	List<PlateType> recentPlateTypes = cc.getRecent(dc, Item.PLATETYPE);
	%>

	<base:page type="popup" title="<%=title%>" id="step-1">
	<base:head scripts="~merge_plates.js" />
	<base:body>
		<h1><%=title%> <base:help helpid="plates.merge.1" /></h1>
		<form action="merge_plates_2.jsp?ID=<%=ID%>" method="post" name="merge">

		<div class="content bottomborder">
			<table class="fullform input100 smaller">
			<tr>
				<th>Plate mapping</th>
				<td>
					<base:select 
						id="platemapping_id"
						clazz="selectionlist required"
						required="true"
						current="<%=null%>"
						recent="<%=recentPlateMappings%>"
						newitem="true"
					/>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input class="text required" type="text" name="name" value="New plate" 
					maxlength="<%=Plate.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<th>Plate type</th>
				<td>
					<base:select 
						id="platetype_id"
						clazz="selectionlist required"
						required="true"
						current="<%=null%>"
						recent="<%=recentPlateTypes%>"
						newitem="true"
					/>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</div>
		</form>
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnNext" title="Next" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
