<%-- $Id: edit_formula.jsp 7604 2019-02-25 12:19:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.Coloring"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.FORMULA;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Formula formula = null;
	Formula.Type currentType = null;
	Type currentValueType = Type.FLOAT;
	Formula.Parser currentParser = null;
	Formula.AverageMethod currentAverageMethod = null;
	RawDataType currentRawDataType = null;
	RawDataType defaultRawDataType = null;
	IntensityTransform currentSourceIntensityTransform = null;
	IntensityTransform currentResultIntensityTransform = null;
	List<String> expressions = null;
	Coloring coloring = null;

	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject =	Project.getById(dc, activeProjectId);
		defaultRawDataType = activeProject.getDefaultRawDataType();
	}	
	if (itemId == 0)
	{
		title = "Create formula";
		cc.removeObject("item");
		String recentType = cc.getRecent("FormulaType", 0);
		String filterType = cc.getPropertyValue("type");
		if (filterType != null) currentType =  Formula.Type.fromValue(Values.getInt(filterType));
		if (currentType == null && recentType != null) currentType = Formula.Type.valueOf(recentType);
		if (currentType == null) currentType = Formula.Type.COLUMN_EXPRESSION;
		currentParser = Formula.Parser.fromValue(Values.getInt(cc.getPropertyValue("parser"), 
			Formula.Parser.JEP.getValue()));
		currentAverageMethod = Formula.AverageMethod.fromValue(Values.getInt(cc.getPropertyValue("averageMethod"),
			Formula.AverageMethod.ARITHMETIC_MEAN.getValue()));
		currentRawDataType = RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
		if (currentRawDataType == null)
		{
			currentRawDataType = RawDataTypes.getRawDataType(cc.getRecent("RawDataType", 0));
		}
		if (cc.getPropertyValue("sourceIntensityTransform") != null)
		{
			currentSourceIntensityTransform = IntensityTransform.fromValue(Values.getInt(cc.getPropertyValue("sourceIntensityTransform")));
		}
		if (cc.getPropertyValue("resultIntensityTransform") != null)
		{
			currentResultIntensityTransform = IntensityTransform.fromValue(Values.getInt(cc.getPropertyValue("resultIntensityTransform")));
		}
		coloring = new Coloring();
		coloring.setUsingColors(Values.getBoolean(cc.getPropertyValue("coloring.usingColors")));
		coloring.setLogarithmic(Values.getBoolean(cc.getPropertyValue("coloring.logarithmic")));
		coloring.setMinValue(Values.getFloat(cc.getPropertyValue("coloring.minValue"), null));
		coloring.setMidValue(Values.getFloat(cc.getPropertyValue("coloring.midValue"), null));
		coloring.setMaxValue(Values.getFloat(cc.getPropertyValue("coloring.maxValue"), null));
		
		currentRawDataType = currentRawDataType != null ? currentRawDataType : defaultRawDataType;
	}
	else
	{
		formula = Formula.getById(dc, itemId);
		formula.checkPermission(Permission.WRITE);
		currentParser = formula.getParser();
		currentAverageMethod = formula.getAverageMethod();
		currentType = formula.getFormulaType();
		currentValueType = formula.getValueType();
		currentRawDataType = formula.getRawDataType();
		currentSourceIntensityTransform = formula.getSourceIntensityTransform();
		currentResultIntensityTransform = formula.getResultIntensityTransform();
		expressions = formula.getFormulas();
		coloring = formula.getColoring();
		cc.setObject("item", formula);
		title = "Edit formula -- " + HTML.encodeTags(formula.getName());
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), formula);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~formulas.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body >
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="formula">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=formula != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Formula" helpid="formula.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=formula == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(formula == null ? Values.getString(cc.getPropertyValue("name"), "New formula") : formula.getName())%>" 
					maxlength="<%=Formula.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Type</th>
				<td>
					<select name="type" class="required" id="formulaType" style="width: 15em;">
					<%
					for (Formula.Type type : Formula.Type.values())
					{
						String selected = type == currentType ? "selected" : "";
						Type valueType = type.getValueType();
						%>
						<option value="<%=type.name()%>" <%=selected%>
							data-supports-colors="<%=type.canUseColoring() ? 1 : 0 %>"
							data-supports-average="<%=type.supportsAverage() ? 1 : 0 %>"
							data-value-type="<%=valueType == null ? "" : valueType.name() %>"
						><%=HTML.encodeTags(type.toString())%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Parser</th>
				<td>
					<select name="parser" class="required" style="width: 15em;">
					<%
					for (Formula.Parser parser : Formula.Parser.values())
					{
						String selected = parser == currentParser ? "selected" : "";
						%>
						<option value="<%=parser.name()%>" <%=selected%>><%=HTML.encodeTags(parser.toString())%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Raw data type</th>
				<td>
					<select name="rawdatatype" id="rawdatatype" style="width: 15em;">
					<option value="">- none -
					<%
					for (RawDataType rdt :  RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
					{
						String selected = rdt == currentRawDataType ? "selected" : "";
						%>
						<option value="<%=rdt.getId()%>" <%=selected%>
							data-channels="<%=rdt.getChannels()%>"
							><%=HTML.encodeTags(rdt.getName())%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Channels</th>
				<td><input <%=currentRawDataType != null ? "class=\"text disabled\" disabled" : "class=\"text required\""%> 
					type="text" name="channels" id="channels"
					style="width:15em;"
					value="<%=formula == null ? (currentRawDataType == null ? Values.getInt(cc.getPropertyValue("channels")) : currentRawDataType.getChannels()) : formula.getChannels()%>" 
					 maxlength="10"
					></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Expressions</th>
				<td>
					<table>
					<tr>
						<td>
						<select name="expressions" id="expressions" size="3" style="width: 26em;"
							multiple class="required">
							<%
							if (expressions != null)
							{
								for (String expression : expressions)
								{
									%>
									<option><%=HTML.encodeTags(expression)%>
									<%
								}
							}
							%>
						</select>
						</td>
						<td><base:button id="btnRemoveExpression" title="Remove" /></td>
						<td></td>
					</tr>
					<tr>
					<td>
						<input type="text" name="expression" id="expression" class="text" style="width: 26em;"
							maxlength="<%=Formula.MAX_FORMULA_LENGTH%>">
					</td>
					<td>
						<base:button id="btnAddExpression" title="Add" />
					</td>
					<td>
						<base:button
							id="btnExpressionBuilder" 
							image="expression_builder.png"
							title="Expression builder&hellip;" />
					</td>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Value type</th>
				<td>
					<select name="valueType" style="width: 15em;">
					<option value="">- unknown -
					<%
					for (Type type : Type.values())
					{
						String selected = type == currentValueType ? "selected" : "";
						%>
						<option value="<%=type.name()%>" <%=selected%>><%=HTML.encodeTags(type.toString())%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Avg. method</th>
				<td>
					<select name="averageMethod" class="required" style="width: 15em;">
					<%
					for (Formula.AverageMethod method : Formula.AverageMethod.values())
					{
						String selected = method == currentAverageMethod ? "selected" : "";
						%>
						<option value="<%=method.name()%>" <%=selected%>><%=HTML.encodeTags(method.toString())%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Intensity<br>transformation</th>
				<td>
					<b>Source</b>
					<select name="sourceIntensityTransform" style="width: 15em;">
					<option value="">- any -
					<%
					for (IntensityTransform t : IntensityTransform.values())
					{
						String selected = t == currentSourceIntensityTransform ? "selected" : "";
						%>
						<option value="<%=t.name()%>" <%=selected%>><%=HTML.encodeTags(t.toString())%>
						<%
					}
					%>
					</select>
					<b>Result</b>
					<select name="resultIntensityTransform" style="width: 15em;">
					<option value="">- any -
					<%
					for (IntensityTransform t : IntensityTransform.values())
					{
						String selected = t == currentResultIntensityTransform ? "selected" : "";
						%>
						<option value="<%=t.name()%>" <%=selected%>><%=HTML.encodeTags(t.toString())%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th></th>
				<td>
					<input type="checkbox" name="use_colors" id="useColors" value="1" 
						<%=coloring.isUsingColors() ? "checked" : "" %>>
					<label for="useColors"><b>Use colors</b></label>
					
					<input type="checkbox" name="logarithmic" id="logarithmic" value="1" 
						<%=coloring.isLogarithmic() ? "checked" : "" %>>
					<label for="logarithmic"><b>Logarithmic</b></label>	
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<b>Min value</b>
					<input type="text" class="text" name="min_value" id="min_value" style="width: 6em;"
						 value="<%=Values.formatNumber(coloring.getMinValue(), -1)%>"
						 maxlength="6">
					<b>Mid value</b>
					<input type="text" class="text" name="mid_value" id="mid_value" style="width: 6em;"
						 value="<%=Values.formatNumber(coloring.getMidValue(), -1)%>"
						 maxlength="6">
					<b>Max value</b>
					<input type="text" class="text" name="max_value" id="max_value" style="width: 6em;"
						 value="<%=Values.formatNumber(coloring.getMaxValue(), -1)%>"
						 maxlength="6">
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" name="description" id="description"
						><%=HTML.encodeTags(formula == null ? cc.getPropertyValue("description") : formula.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
