
package com.dawidweiss.ant.taskdefs;

import org.apache.tools.ant.*;


/**
 * A liaison class for Saxon XSLT processor.
 */
public final class GetSystemProperty {

	private String antproperty;
	private String sysproperty;
	private Project project;
	
	public void setAntProperty(String name) {
		this.antproperty = name;
	}

	public String getAntProperty() {
		return this.antproperty;
	}

	public void setSysProperty(String name) {
		this.sysproperty = name;
	}

	public String getSysProperty() {
		return this.sysproperty;
	}

	public void setProject(Project project) {
		this.project = project;
	}

	public void execute() throws BuildException {
		if (this.antproperty == null)
			throw new BuildException("ant-property attribute missing.");
		if (this.sysproperty == null)
			throw new BuildException("sys-property attribute missing.");

		project.setProperty( antproperty, System.getProperty( sysproperty ));
	}

}
